//
// Home scene
//
var Game = Game || {};
var lines = [
	Game.getLocalizedString('dialogue000'),
	Game.getLocalizedString('dialogue001')
];
var line = 1;
var knockInterval = 5.0;
var wakeCue = knockInterval + 1.0;

Game.onNextDialogue = function() {
	if (line < lines.length) {
		Game.dialogue(lines[line]);
		line++;
	}
	else {
		Game.lockInput(false);
	}
};

var player = Game.getLevelObject('player');
var playerPos = player.getPosition();
Game.lockInput(true);

// fade in
var fade = cc.LayerColor.create({r: 0, g: 0, b: 0, a: 255});
fade.runAction(cc.Sequence.create(
	cc.EaseSineOut.create(cc.FadeOut.create(knockInterval * 2)),
	cc.RemoveSelf.create()
));
player.getParent().addChild(fade, 200);

// player's animation
cc.director.getScheduler().scheduleCallbackForTarget(player, function() {
	// open eyes
	Game.animateLevelObject(player, 'wake');

	cc.director.getScheduler().scheduleCallbackForTarget(player, function() {
		// sit up
		Game.animateLevelObject(player, 'wake2');
		
		cc.director.getScheduler().scheduleCallbackForTarget(player, function() {
			// say first line
			Game.dialogue(lines[0]);
		}, 0, 0, 1.2);
	}, 0, 0, knockInterval);
}, 0, 0, wakeCue);
Game.animateLevelObject(player, 'sleep');

// zzz
var z = function() {
	var s = cc.Sprite.createWithSpriteFrameName('Z.png');
	var pos = {x: 0, y: 0};
	pos.x = Game.scale(-15.0 + Game.randf01() * 5.0);
	pos.y = Game.scale(Game.randf01() * 5.0);
	s.setPosition(pos);
	s.setRotation(-5 - Game.randf01() * 5);
	player.addChild(s);
	s.runAction(cc.FadeOut.create(2.0));
	s.runAction(cc.ScaleTo.create(2.0, 0.5));
	s.runAction(cc.Sequence.create(
		cc.MoveBy.create(2.0, {x:-20 + Game.randf01() * 20, y:10 + Game.randf01() * 20}),
		cc.RemoveSelf.create()
	));
};
cc.director.getScheduler().scheduleCallbackForTarget(player, z, 1, 5);

// knock knock
var knockKnock = function() {
	cc.audioEngine.playEffect('Home-KnockKnock.wav');

	var i, s, pos = {x: 0, y: 0};
	for (i = 0; i < 4; i++)
	{
		s = cc.Sprite.createWithSpriteFrameName('Knock.png');
		pos.x = playerPos.x + Game.scale(236 + (i % 2) * 25);
		pos.y = playerPos.y + Game.scale(-40 + i * 20);
		s.setPosition(pos);
		s.setVisible(false);
		s.setRotation(-5 + (i % 2) * 10);
		s.setScale(2);
		player.getParent().addChild(s);
		s.runAction(cc.Sequence.create(
			cc.DelayTime.create(0.34 * i),
			cc.Show.create(),
			cc.DelayTime.create(1),
			cc.FadeOut.create(0.1),
			cc.RemoveSelf.create()
		));
	}
};
cc.director.getScheduler().scheduleCallbackForTarget(player, knockKnock, knockInterval);
