#ifdef GL_ES
#define LOWP lowp
precision mediump float;
#else
#define LOWP
#endif

#define PI 3.14

varying vec2 v_texCoord;
varying vec4 v_fragmentColor;

uniform vec2 u_lightOffset;
uniform vec3 u_lightColor1;
uniform vec3 u_lightColor2;
uniform float u_radius;
uniform vec2 u_resolution;

void main() {
	vec2 v = gl_FragCoord.xy / u_resolution;
	v += u_lightOffset;
	v -= 1.0;
	v.y *= u_resolution.y / u_resolution.x;
	float distance = length(v);
	distance *= u_radius;
	vec4 color = vec4(0, 0, 0, 0);
	if (distance < 0.54)
	{
		// yellow 0 - 0.17
		if (distance < 0.17 && (u_lightColor1.r > 0.0 || u_lightColor1.g > 0.0 || u_lightColor1.b > 0.0))
			color += vec4(u_lightColor1, 0.1) * ((0.17 - distance) / 0.17);

		// blue 0.085 - 0.28 - 0.54
		if (distance > 0.085)
		{
			if (distance < 0.28)
				color += vec4(u_lightColor2, 0.05) * ((distance - 0.085) / 0.195);
			else
				color += vec4(u_lightColor2, 0.05) * (1.0 -((distance - 0.28) / 0.26));
		}
	}
	else
		color.a = clamp(distance - 0.69, 0.0, 0.8);

	gl_FragColor = color;
}
